import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:path_stack/path_stack.dart';

class HelloWorldExample extends StatefulWidget {
  @override
  _HelloWorldExampleState createState() => _HelloWorldExampleState();
}

class _HelloWorldExampleState extends State<HelloWorldExample> {
  String path = "page1";

  @override
  void initState() {
    RawKeyboard.instance.addListener((value) {
      if (value is RawKeyDownEvent) {
        final k = value.logicalKey;
        if (k == LogicalKeyboardKey.digit1) setState(() => path = "page1");
        if (k == LogicalKeyboardKey.digit2) setState(() => path = "page2");
        if (k == LogicalKeyboardKey.digit3) setState(() => path = "page3/");
        if (k == LogicalKeyboardKey.digit4) setState(() => path = "page3/subPage1");
        if (k == LogicalKeyboardKey.digit5) setState(() => path = "page3/subPage2");
      }
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return PathStack(path: path, routes: {
      ["page1"]: Container(color: Colors.red).toStackRoute(),
      ["page2"]: Container(color: Colors.green).toStackRoute(),
      ["page3/"]: PathStack(
        routes: {
          ["subPage1", ""]: Container(color: Colors.orange).toStackRoute(), //matches: /page3/subPage1 or /page3/
          ["subPage2"]: Container(color: Colors.purple).toStackRoute(), //matches: /page3/subPage2
        },
      ).toStackRoute(),
    });
  }
}
